import hyperHTML from 'hyperhtml/esm';
import { AbstractElement } from './abstract-element';
export class AbstractHyperElement extends AbstractElement {
    constructor(staticStyle = '', shadow = false, mode = 'open') {
        super();
        this.html = hyperHTML.wire(this);
        this.wire = hyperHTML.wire;
        try {
            this._style = staticStyle;
        }
        catch (error) {
            console.warn('Can not find a static style!');
        }
        if (shadow) {
            this.attach = hyperHTML.bind(this.attachShadow({ mode }));
        }
        else {
            this.attach = hyperHTML.bind(this);
        }
        if (this._style && this._style !== '') {
            this._style = hyperHTML.wire() `<style>${this._style}</style>`;
        }
    }
    renderElement() {
        if (this.connected) {
            this.attach `${this._style}${this.render()}`;
        }
    }
}
//# sourceMappingURL=abstract-element-hyper.js.map