import * as litHtml from 'lit-html';
import { AbstractElement } from './abstract-element';
export class AbstractLitElement extends AbstractElement {
    constructor(staticStyle = '', shadow = false, mode = 'open') {
        super();
        this.html = litHtml.html;
        try {
            this._style = staticStyle;
        }
        catch (error) {
            console.warn('Can not find a static style!');
        }
        if (shadow) {
            this.attach = ((a, b) => { litHtml.render(b, a); }).bind(null, this.attachShadow({ mode }));
        }
        else {
            this.attach = ((a, b) => { litHtml.render(b, a); }).bind(null, this);
        }
        if (this._style && this._style !== '') {
            this._style = this.html `<style>${this._style}</style>`;
        }
    }
    renderElement() {
        if (this.connected) {
            this.attach(this.html `${this._style}${this.render()}`);
        }
    }
}
AbstractLitElement.attrNames = {};
//# sourceMappingURL=abstract-element-lit.js.map